ssb-g1-tip/process-likes-g1tx.sh

436 lines
12 KiB
Bash
Raw Normal View History

2020-03-13 17:52:08 +01:00
#!/bin/bash
################################################################################
# Authors:
# [@cel](@f/6sQ6d2CMxRUhLpspgGIulDxDCwYD7DzFzPNr7u5AU=.ed25519)
# [@Fred](@9BbJwPDjcyIqrOUPNn0nJZBduWdIrpMk3Cjz5MP361s=.ed25519)
2020-03-14 01:50:28 +01:00
# [@Boris](@l5nYExWYIgDLV6BYHOJPoI97jIUyTdSm8CTLpQ0XeOg=.ed25519)
2020-03-13 17:52:08 +01:00
# Version: 1.0
# License: AGPL-3.0 (https://choosealicense.com/licenses/agpl-3.0/)
###########################################################################################
# PREVENT DOUBLE PAYEMENT
2020-03-18 20:41:11 +01:00
# ADD Ğ1 Layer 10 LOVE to message writer you like !
2020-03-13 17:52:08 +01:00
############################################################################################
2020-03-18 20:41:11 +01:00
# Let's get Ğ1 public and private keys
2020-03-13 17:52:08 +01:00
g1pub=$(cat ~/.ssb/secret.dunikey | grep "pub" | cut -d ' ' -f 2)
g1priv=$(cat ~/.ssb/secret.dunikey | grep "sec" | cut -d ' ' -f 2)
# SSB pubkey
ssbpub=$(cat ~/.ssb/secret | grep public\" | cut -d ' ' -f 4 | cut -d '.' -f 1 | sed s/\"//g)
defaultAmountPerLikeInUD="0.05"
2020-03-18 20:41:11 +01:00
bold=$(tput bold)
normal=$(tput sgr0)
2020-03-19 00:56:23 +01:00
ssbMaxSize=8192
ssbMsgHeadersSize=5810 # Here is a wild guess!
2020-03-13 17:52:08 +01:00
############################################################################################
#### CHECK LIKE AND SEND LOVE
2020-03-18 20:41:11 +01:00
# Let's get Ğ1 account balance
2020-03-13 17:52:08 +01:00
echo ""
2020-03-18 20:41:11 +01:00
echo -e "${bold}Welcome${normal} to the Ğ1/SSB-like microdonation system!\n"
sleep 1
echo "MMMMMMMMMMMMMNk;'cdxxd:,c0WMMMMMMMMMMMMM
2020-03-13 17:52:08 +01:00
MMMMMMMMMMMMMNx,. .;kWMMMMMMMMMMMMM
MMMMMMMMMMMMMMMNOdlccld0NMMMMMMMMMMMMMMM
MMMMMMMMMMMWXko:,'....',:okXWMMMMMMMMMMM
MMMMMMMMMNk:. .cOWMMMMMMMMM
2020-03-18 20:41:11 +01:00
MMMMMMMW0: .c0MMMMMMMM"
sleep 1
echo "MMMMMMWk. 'lxkOOkdc' .cOWMMMMMMM
2020-03-13 17:52:08 +01:00
MMMMMMO' 'kNMMMMMMMMNxcoOXWMMMMMMMMM
MMMMMNl '0MMMMMMMMMMMMMMMMMMMMMMMMMM
MMMMMX; cNMMMMMMMNOkkkkkkkkkkONMMMMM
MMMMMNc ;XMMMMMMMNd' .OMMMMM
MMMMMWx. cKMMMMMMMWKc. .OMMMMM
2020-03-18 20:41:11 +01:00
MMMMMMNo. .lkKXNNXKkc. .OMMMMM"
sleep 1
echo "MMMMMMMNd. ...... .OMMMMM
2020-03-13 17:52:08 +01:00
MMMMMMMMWKl. 'c:. .OMMMMM
MMMMMMMMMMWXkc,.. ..,lkXWWO:;OMMMMM
MMMMMMMMMMMMMMWX0OxddxO0XWMMMMMMWXNMMMMM
MMMMMMMMMMMMMMMMNx;'',dNMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMK, '0MMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMNd. .oNMMMMMMMMMMMMMMMM
"
sleep 1
2020-03-18 20:41:11 +01:00
printf "You know your SSB pubkey:\n%s\n\n" $ssbpub
2020-03-13 17:52:08 +01:00
sleep 2
2020-03-18 20:41:11 +01:00
printf "...but did you know it is also a valid Ğ1 wallet?\n%s\n\n" $g1pub
2020-03-13 17:52:08 +01:00
sleep 2
2020-03-18 20:41:11 +01:00
printf "Let's check the current balance of your wallet!\n\n"
2020-03-13 17:52:08 +01:00
sleep 1
2020-03-19 00:56:23 +01:00
printf "I am interrogating the Ğ1 blockchain to check if anyone has already sent you Ğ1...\n\n"
2020-03-18 20:41:11 +01:00
sleep 2
printf "A moment please...\n\n"
2020-03-13 17:52:08 +01:00
sleep 1
2020-03-18 20:41:11 +01:00
silkajRelativeAmountPattern='Total\sRelative\s+=\s+(.*)\s+UD'
2020-03-19 00:56:23 +01:00
duniter_servers[0]="duniter-g1.p2p.legal:443"
duniter_servers[1]="g1.duniter.org:443"
duniter_servers[2]="g1.presles.fr:443"
duniter_servers[3]="balboa.altsysnet.com:10900"
duniter_servers[4]="remuniter.cgeek.fr:16120"
duniter_servers[5]="duniter.moul.re:443"
duniter_servers[6]="77.152.31.154:20901"
duniter_servers[7]="duniter.g1.1000i100.fr:443"
silkajExitCode=1
i=0
while [ $silkajExitCode -ne 0 ] && [ $i -lt ${#duniter_servers[@]} ]
do
echo "Testing server ${duniter_servers[$i]}..."
2020-03-13 17:52:08 +01:00
echo ""
2020-03-19 00:56:23 +01:00
silkajOutput=$(silkaj -p "${duniter_servers[$i]}" balance $g1pub 2>/dev/null)
silkajExitCode=$?
((i++))
done
2020-03-13 17:52:08 +01:00
2020-03-19 00:56:23 +01:00
if [ $silkajExitCode -eq 1 ]
then
echo "The server did not respond well. Please try again."
exit 1
2020-03-13 17:52:08 +01:00
fi
2020-03-18 20:41:11 +01:00
if [[ $silkajOutput =~ $silkajRelativeAmountPattern ]]
then
balance="${BASH_REMATCH[1]}"
else
echo "Account balance wasn't found."
exit 1
fi
printf "You have ${bold}%s UDĞ1${normal} on your Duniter Ğ1 wallet.\n\n" "$balance"
sleep 2
printf "Want to show your appreciation of your fellow butts' posts while helping spreading awareness about libre currencies?\n\n"
sleep 3
2020-03-18 20:41:11 +01:00
# BEGIN timestamp computation
2020-03-13 17:52:08 +01:00
self=$(sbotc whoami | jq -r .id) || exit 1
ssb_dir=~/.${ssb_appname:-ssb}
id_part=$(echo "$self" | sed 's/\//_/g' | tail -c +2 | head -c 9)
state_file=$ssb_dir/likes-g1-$id_part.ts
2020-03-18 20:41:11 +01:00
current_ts=$(date -u +%s%N | cut -b1-13)
2020-03-13 17:52:08 +01:00
if [ -s "$state_file" ]
2020-03-18 20:41:11 +01:00
then
last_ts=$(cat "$state_file") || exit 1
2020-03-13 17:52:08 +01:00
else
2020-03-18 20:41:11 +01:00
last_ts=$((current_ts - 3600000)) # timestamp from 1h ago
2020-03-13 17:52:08 +01:00
#else last_ts=null
fi
2020-03-18 20:41:11 +01:00
days_from_last_tx=$(( (current_ts - last_ts) / (24*60*60*1000) ))
# END timestamp computation
printf "First, let's see how much ❤ you gave lately...\n\n"
sleep 1
declare -A likesNbPerAuthor
declare -A likedPosts
declare -A likesNbPerPost
declare -A postsTimestamps
declare -A excerpts
totalLikesGiven=0
2020-03-13 17:52:08 +01:00
process_msg() {
2020-03-18 20:41:11 +01:00
2020-03-13 17:52:08 +01:00
msg=$1
target_id=$(printf %s "$msg" | jq -r '.value?.content?.vote?.link') || return 1
target_msg=$(sbotc -e get "$target_id") || return 1
target_author=$(printf %s "$target_msg" | jq -r .author) || return 1
2020-03-18 20:41:11 +01:00
msg_content=$(printf %s "$target_msg" | jq -r .content?.text) || return 1
# beware of markdown !
msg_excerpt=${msg_content:0:10}
#root_id=$(printf %s "$target_msg" | jq -r .content?.root) || return 1
#[[ $root_id = "null" ]] && root_id=$target_id
2020-03-13 17:52:08 +01:00
}
2020-03-18 20:41:11 +01:00
process_author() {
author_id=$1
g1_author=$(echo $author_id | cut -d '.' -f 1 | cut -d '@' -f2 | base64 -d | base58)
author_name=$(sbotc query.read '{"query":[{"$filter":{"value":{"author": "'"$author_id"'", "content":{"type":"about", "about": "'"$author_id"'"}}}}]}' | jq .value?.content?.name | grep -v null | tail -n 1)
}
authorsNb=0
i=0
messages=$(sbotc query.read '{"query":[{"$filter":{"value":{"author":"'"$self"'","content":{"type":"vote", "vote":{"expression":"Like"}},"timestamp":{"$gt":'"$last_ts"'}}}}]}')
while read -r msg
2020-03-13 17:52:08 +01:00
do
2020-03-18 20:41:11 +01:00
2020-03-16 01:15:07 +01:00
priv=$(printf %s "$msg" | jq .value.content.private)
2020-03-18 20:41:11 +01:00
if [[ $priv = true ]]
2020-03-16 01:15:07 +01:00
then
printf "Private message $priv, continue to next one\n" >&2
continue
fi
2020-03-13 17:52:08 +01:00
if ! process_msg "$msg"
then
msg_id=$(printf %s "$msg" | jq -r .key)
2020-03-18 20:41:11 +01:00
printf '\nUnable to process message %s\n' "$msg_id" >&2
2020-03-13 17:52:08 +01:00
exit 1
fi
2020-03-18 20:41:11 +01:00
if [[ $g1_author = $g1pub ]]; then
2020-03-18 20:41:11 +01:00
echo "I LIKE MY MESSAGE $target_id"
else
((totalLikesGiven++))
2020-03-18 20:41:11 +01:00
if [[ ${likesNbPerAuthor[$target_author]} -eq 0 ]]
then
likesNbPerAuthor[$target_author]=1
likedPosts[$target_author]=""
else
likesNbPerAuthor[$target_author]=$((${likesNbPerAuthor[$target_author]} + 1))
fi
2020-03-18 20:41:11 +01:00
if [[ ${likesNbPerPost[$target_id]} -eq 0 ]]
then
likesNbPerPost[$target_id]=1
likedPosts[$target_author]+=$target_id
likedPosts[$target_author]+="\n"
else
((likesNbPerPost[$target_id]++))
fi
2020-03-18 20:41:11 +01:00
excerpts[$target_id]=$msg_excerpt
if ! postsTimestamps[$target_id]=$(printf %s "$msg" | jq -r .value.timestamp)
then
printf 'Unable to get message timestamp\n' >&2
exit 1
fi
((i++))
2020-03-13 17:52:08 +01:00
fi
2020-03-18 20:41:11 +01:00
done < <(printf '%s\n' "$messages")
if [[ $totalLikesGiven -eq 0 ]]
then
printf "You did not give any like during the past %s days or they have already been processed.\n\n" "$days_from_last_tx"
printf "Try again in a few days.\n\n"
fi
printf "You gave ${bold}%s❤${normal} during the past %s days.\n\n" "$totalLikesGiven" "$days_from_last_tx"
sleep 2
2020-03-19 00:56:23 +01:00
tx_are_possible=0
2020-03-18 20:41:11 +01:00
2020-03-19 00:56:23 +01:00
while [[ $tx_are_possible -eq 0 ]]
do
printf "How many UDĞ1 do you want to send per each like you gave? (default is ${bold}%s UDĞ1${normal}) " "$defaultAmountPerLikeInUD"
read a
printf "\n"
if [[ -z $a ]]
then
amountPerLikeInUD=$defaultAmountPerLikeInUD
else
amountPerLikeInUD=$a
fi
2020-03-19 00:56:23 +01:00
amountGiven=$(echo "$totalLikesGiven * $amountPerLikeInUD" | bc -l)
tx_are_possible=$(( $(echo "$amountGiven <= $balance" | bc -l) ))
sleep 1
2020-03-19 00:56:23 +01:00
if [[ $tx_are_possible -ne 0 ]] ; then
newBalance=$(echo "$balance - $amountGiven" | bc -l)
printf "${bold}%s UDĞ1${normal} will be given.\n\n" "$amountGiven"
sleep 1
printf "After sending transactions, your new balance will be ${bold}%s UDĞ1${normal}\n\n" "$newBalance"
sleep 1
printf "Press ENTER to continue: " && read
printf "\n"
else
printf "You don't have enough UDĞ1 to send all transactions.\n\n"
sleep 1
printf "${bold}%s UDĞ1${normal} are needed.\n\n" "$amountGiven"
sleep 1
printf "Try again with a different amount per like.\n\n"
maxAmountPerLike=$(awk -vp=$balance -vq=$totalLikesGiven 'BEGIN{printf "%.2f" ,p / q}')
sleep 1
printf "Maximum amount per like possible: ${bold}%s UDĞ1${normal}\n\n" "$maxAmountPerLike"
sleep 1
fi
done
2020-03-18 20:41:11 +01:00
# Let's construct thank you message and send transactions!
2020-03-19 00:56:23 +01:00
n=0
outputs[$n]=""
outputs[$n]+=$(printf "Huge thanks to the ScuttleButt community for all the fascinating posts you allowed me to read in the past %s days." "$days_from_last_tx")
outputs[$n]+="\n\nAs a means to thank you further, I have just sent you #Ğ1 libre money.\n\n"
outputs[$n]+="These messages, though they might feel spammy (sorry) are also a way for the Ğ1 community to spread awareness about [libre currencies](https://libre-currency.org/) so we can build #resilience at every level.\n\n"
outputs[$n]+="You can learn how to spend your freshly earned money at [https://git.p2p.legal/Axiom-Team/ssb-g1like](https://git.p2p.legal/Axiom-Team/ssb-g1like)\n\n"
outputs[$n]+="Below is the list of SSB users whose content I liked recently, and the amount each one was given:\n\n"
tableHeaders='| thanks to | for their posts | given |\n'
tableHeaders+='| --- | --- | ---- |\n'
outputs[$n]+=$tableHeaders
2020-03-18 20:41:11 +01:00
for author_id in ${!likesNbPerAuthor[@]}
do
process_author $author_id
# (Legacy) saving authors we have already mentionned in a message
likedAuthorsFile=$ssb_dir/db/g1likes
if [ ! -f $likedAuthorsFile ]; then
touch $likedAuthorsFile
fi
if ! grep -Fxq $author_id $likedAuthorsFile; then
echo $author_id >> $likedAuthorsFile
fi
2020-03-19 00:56:23 +01:00
2020-03-18 20:41:11 +01:00
author_amount=$(bc <<< "${likesNbPerAuthor[$author_id]} * $amountPerLikeInUD")
2020-03-19 00:56:23 +01:00
newLine=''
newLine+=$(printf "| [@%s](%s) " "${author_name:1:-1}" "$author_id")
newLine+="| "
2020-03-18 20:41:11 +01:00
posts=${likedPosts[$author_id]}
thisAuthorLikedPosts=( ${posts//\\n/ } )
2020-03-19 00:56:23 +01:00
firstPost=1
2020-03-18 20:41:11 +01:00
for post_id in ${thisAuthorLikedPosts[@]}
do
2020-03-19 00:56:23 +01:00
if [[ $firstPost ]]
2020-03-18 20:41:11 +01:00
then
2020-03-19 00:56:23 +01:00
firstPost=0
else
newLine+=", "
2020-03-18 20:41:11 +01:00
fi
2020-03-19 00:56:23 +01:00
newLine+=$(printf " %s❤" "${likesNbPerPost[$post_id]}")
newLine+=$(printf "[\`%s\`](%s)" "${excerpts[$post_id]}" "$post_id")
2020-03-18 20:41:11 +01:00
done
2020-03-19 00:56:23 +01:00
newLine+=$(printf "| %s UDĞ1 " $author_amount)
newLine+="|\n"
messageSize=$(printf "%s%s" "${outputs[$n]}" "$newLine" | wc -c)
totalSize=$((messageSize + ssbMsgHeadersSize))
if [[ $totalSize -gt $ssbMaxSize ]]
then
outputs[$n]+="For message size reasons, the rest of the list had to be displayed below, in the following answer:"
((n++))
outputs[$n]+=$tableHeaders
fi
outputs[$n]+=$newLine
2020-03-18 20:41:11 +01:00
2020-03-19 00:56:23 +01:00
#printf '%s\n' "silkaj -af --file ~/.ssb/secret.dunikey tx --outputs[$n] $g1_author --amountUD $author_amount --comment "Thx for your cool posts on ScuttleButt"
2020-03-19 02:05:25 +01:00
silkaj -p "$duniter_server" -af --file ~/.ssb/secret.dunikey tx --outputs[$n] $g1_author --amountUD $author_amount --comment "Thx for your cool posts on ScuttleButt" -y 2>/dev/null
2020-03-18 20:41:11 +01:00
printf "\n${bold}%s UDĞ1${normal} sent to %s!\n\n" "$author_amount" "${author_name:1:-1}"
# Let's save the timestamp of the last processed message
if ! echo "${postsTimestamps[$target_id]}" > "$state_file"~
2020-03-13 17:52:08 +01:00
then
2020-03-18 20:41:11 +01:00
printf 'Unable to write to backup state file.\n' >&2
2020-03-13 17:52:08 +01:00
exit 1
fi
2020-03-18 20:41:11 +01:00
2020-03-19 02:05:25 +01:00
if ! mv "$state_file"~ "$state_file"
then
msg_id=$(printf %s "$msg" | jq -r .key)
printf 'Unable to write to state file. Update state file manually to prevent %s from being processed twice.\n' "$msg_id" >&2
exit 1
fi
2020-03-18 20:41:11 +01:00
2020-03-19 02:07:18 +01:00
sleep 20 # DO NOT OVER CHARGE DUNITER
2020-03-13 17:52:08 +01:00
done
2020-03-18 20:41:11 +01:00
2020-03-19 00:56:23 +01:00
printf "\n%s UDĞ1 sent to %s butts!\n\n" "$amountGiven" "${#likesNbPerAuthor[@]}"
2020-03-18 20:41:11 +01:00
# Let's publicly thank everyone!
2020-03-19 00:56:23 +01:00
#echo -e "${outputs[$n]}"
2020-03-18 20:41:11 +01:00
# the following produces error:
# "sbotc: unexpected end of parent stream"
# must be a non-escaped quote problem...
2020-03-19 00:56:23 +01:00
#thank_you_msg=$(printf "%q" "${outputs[$n]}")
2020-03-18 20:41:11 +01:00
#sbotc publish '{"type":"post","text":"'"$thank_you_msg"'"}' 2>&1>/dev/null
printf "What now ?\n\n"
sleep 1
2020-03-19 00:56:23 +01:00
date=$(date -u +%Y-week-%W)
2020-03-18 20:41:11 +01:00
2020-03-19 00:56:23 +01:00
if [[ ${#outputs[@]} -eq 1 ]]
then
msg_filename=thank-your-butts-$date
echo -e ${outputs[$n]} > ~/$msg_filename
else
for i in ${!outputs[@]}
do
part=$((i + 1))
msg_filename=thank-your-butts-$date
echo -e ${outputs[$i]} > ~/$msg_filename-part-$part.md
done
fi
2020-03-18 20:41:11 +01:00
2020-03-19 00:56:23 +01:00
printf "A surprise is awaiting in your home dir (~).\n\n"
2020-03-18 20:41:11 +01:00
sleep 2
2020-03-19 00:56:23 +01:00
if [[ ${#outputs[@]} -eq 1 ]]
then
printf "It's a file.\n\n"
sleep 2
printf "It's called $msg_filename.md\n\n"
else
printf "It's %s files.\n\n" "${#outputs[@]}"
sleep 2
printf "The first one is called $msg_filename-part-1.md.\n\n"
fi
2020-03-18 20:41:11 +01:00
sleep 2
printf "Customize it to your needs to thank your fellow butts publicly and help spread awareness about libre currencies :-)\n\n"
2020-03-18 20:41:11 +01:00
sleep 3
printf "Then delete it.\n\n"
sleep 2
printf "...because it won't self-destruct, haha :D \n\n"